import { ColumnSchema } from "./ColumnSchema";
import { IndexSchema } from "./IndexSchema";
import { ForeignKeySchema } from "./ForeignKeySchema";
import { UniqueKeySchema } from "./UniqueKeySchema";
import { PrimaryKeySchema } from "./PrimaryKeySchema";
import { TableMetadata } from "../metadata/TableMetadata";
import { ColumnMetadata } from "../metadata/ColumnMetadata";
import { QueryRunner } from "../driver/QueryRunner";
export declare class TableSchema {
    name: string;
    columns: ColumnSchema[];
    indices: IndexSchema[];
    foreignKeys: ForeignKeySchema[];
    uniqueKeys: UniqueKeySchema[];
    primaryKey: PrimaryKeySchema | undefined;
    constructor(name: string);
    removeColumn(column: ColumnSchema): void;
    removeIndex(indexSchema: IndexSchema): void;
    removeForeignKey(foreignKey: ForeignKeySchema): void;
    removeUniqueByName(name: string): void;
    removePrimaryKey(): void;
    static createFromMetadata(queryRunner: QueryRunner, tableMetadata: TableMetadata, columnMetadatas: ColumnMetadata[]): TableSchema;
    findChangedColumns(queryRunner: QueryRunner, columnMetadatas: ColumnMetadata[]): ColumnSchema[];
}
